function [ log_prior , log_adap_dens] = comp_prior(u1h,u2h, kmod, KX, KY ,Lambdas, k_thresh, mu , Sigma,n)
%Log-Prior density for the low frequency box
%   Detailed explanation goes here

blk_ind=(n/2+1-k_thresh):(n/2+1+k_thresh);

fourier2D=(KY.*u1h-KX.*u2h)./kmod;
fourier2D=fftshift(fourier2D);

fourier2D=fourier2D(blk_ind,blk_ind);

Lambdas=fftshift(Lambdas);
Lambda_l=Lambdas(blk_ind,blk_ind);


log_prior_temp=(real(fourier2D).^2+imag(fourier2D).^2)./Lambda_l;
log_prior_temp(k_thresh+1,k_thresh+1)=0;

log_prior=-0.5*sum(sum(log_prior_temp));

% symmetries
log_prior=log_prior/2;

% Block 1 (left columns without column with k1=0)
size1=(k_thresh^2)*2+k_thresh;
block1=reshape(fourier2D(1:size1),size1,1);
% Block 2 
block2=fourier2D(1:k_thresh,k_thresh+1);

% % Block 3
% block3=fourier2D((k_thresh+2):end,k_thresh+1);

vort_vec=[real(block1);
          real(block2);
%           real(block3);
          imag(block1);
          imag(block2);
%           imag(block3)
];

log_adap_dens=-0.5*(vort_vec-mu)'*(Sigma^-1)*(vort_vec-mu);

end