function [ matrix ] = get_vort_matrix( vec , half_width)
% Takes stacked  vector of real and imaginary low frequency modes and
% returns a matrix of size (2xhalf width+1)x(2xhalf width+1).
%   check at get_vort_vec to see how the vec is generated.
%  NOTE MATRIX IS NOT MATLAB FFT-SHIFTED
% N. Kantas Nov 12

dimvec=length(vec);

% split in real and imaginary part resp
vec1=vec(1:dimvec/2);
vec2=vec((1+dimvec/2):end);


dim1=(2*(half_width^2)+half_width);
block1re=reshape(vec1(1:dim1),2*half_width+1,half_width);
block1im=reshape(vec2(1:dim1),2*half_width+1,half_width);

% fliplr block 1
antiblock1re=-(rot90(block1re,2));
antiblock1im=(rot90(block1im,2));


dim2=(2*(half_width^2+half_width));
block2re=reshape(vec1((1+dim1):dim2),half_width,1);
block2im=reshape(vec2((1+dim1):dim2),half_width,1);

block3re=zeros(size(block2re));

block3im=zeros(size(block2im));



A=[block1re, [block2re;0;block3re], antiblock1re];
B=[block1im, [block2im;0;block3im], antiblock1im];

% flipud matrix for k1=0 column
A((half_width+2):end,half_width+1)=-(flipud(A(1:half_width,half_width+1)));
B((half_width+2):end,half_width+1)=(flipud(B(1:half_width,half_width+1)));

matrix=complex(A,B);


end

