function [ likeli ] = log_likeli_k(k,n,np,u1h,u2h,y1,y2,gamma,observation_type)
%   log likelihood  of each particle, i.e g(Y| \Phi^k(x_0))
%   covariance is I*gamma
switch lower(observation_type)
    case 'euler'
        
        % time domain ifft
        u1=ifft2(u1h)*n*n;
        u2=ifft2(u2h)*n*n;
        
        u1r=red2d(real(u1),n,np);
        u2r=red2d(real(u2),n,np);
        
        likeli_matrix1=-.5*((y1(k)-u1r(k)).^2)/(gamma);
        likeli_matrix2=-.5*((y2(k)-u2r(k)).^2)/(gamma);
        
        likeli=likeli_matrix1+likeli_matrix2;
        
        
    case 'fourier'
        
%         u1=ifftshift(u1h);
%         u2=ifftshift(u2h);
%         
%         x_dim=size(u1,1);
%         
%         center_0=x_dim/2+1;
%         start=center_0-np;
%         fin=center_0+np;
%         
%         u1r=u1(start:fin,start:fin);
%         u2r=u2(start:fin,start:fin);
%         
%         likeli_matrix1=-.5*((y1-u1r).^2)/(gamma);
%         likeli_matrix2=-.5*((y2-u2r).^2)/(gamma);
%         
%         likeli=sum(sum(likeli_matrix1))+sum(sum(likeli_matrix2));
        
        
end

end

