% mcmc move for particle ii 

% register stores for initial and final fields
Sample=cell(num_mcmc_moves+1,2);
Sample_t=cell(num_mcmc_moves+1,2);
log_likeli_store=cell(num_mcmc_moves+1,1);
likeli=zeros(num_mcmc_moves+1,1);

% iteration 0

% record initial velocity field
        
Sample{1,1}=U1{ii,1};
Sample{1,2}=U2{ii,1};
       
% record last velocity field

Sample_t{1,1}=U1{ii,2};
Sample_t{1,2}=U2{ii,2};

log_likeli_store{1,1}=U3{ii,1};

[ log_prior , log_adap_dens] = comp_prior(Sample{1,1},Sample{1,2}, kmod, KX, KY ,Lambdas, k_thresh, mu , Sigma,n);

% old part in the acceptance ratio: different cell due to tempering
likeli(1)=sum(U3{ii,1})+log_prior - log_adap_dens;

for m=1:num_mcmc_moves
     
    [ u1h_l1,u2h_l1] = get_adap_sample_low_freq( mu,Sigma,k_thresh,n,delta, alph,rho1 );
    dim_l=length(u1h_l1)^2;
            
    u1h_temp=fftshift(Sample{m,1});    
    u1h_l2=rho1*u1h_temp(blk_ind,blk_ind);
    
    u1h_box=u1h_l2+fftshift(u1h_l1);    
        
    u2h_temp=fftshift(Sample{m,2});    
    u2h_l2=rho1*u2h_temp(blk_ind,blk_ind);
    
    u2h_box=u2h_l2+fftshift(u2h_l1);    
     
    
    % % % % % % % % % % % % % % % % % %     
    
    SampleFromPrior        
  
    % % % RW proposal=rho*particle+sqrt(1-rho^2)*prior %  %  %
    u1h=rho*Sample{m,1}+sqrt(1-rho^2)*u1h;
    u2h=rho*Sample{m,2}+sqrt(1-rho^2)*u2h;    
    
    u1h_SHIFT=fftshift(u1h);
    u2h_SHIFT=fftshift(u2h);
    
    u1h_SHIFT(blk_ind,blk_ind)=u1h_box;
    u2h_SHIFT(blk_ind,blk_ind)=u2h_box;
    
    u1h=ifftshift(u1h_SHIFT);
    u2h=ifftshift(u2h_SHIFT);
            
    [Sample_log_prior,Sample_log_dens]  = comp_prior(u1h,u2h, kmod, KX, KY ,Lambdas, k_thresh,mu,Sigma,n);
        
    proposal1=u1h;
    proposal2=u2h;
    
    if j1>1
        log_like_ii=zeros(1,j1-1);
    end
    log_like_ii_2=zeros(1,kk);
    
    for kk1=1:j1 % steps till next datapoint
        for kk2=1:intsteps % intermediate integration steps           
            [u1h,u2h]=ns2dstepaa(u1h,u2h,n,h);            
        end
        if kk1<j1
            log_like_ii(kk1)=log_likeli(n,np,u1h,u2h,y1{kk1},y2{kk1},gamma,observation_type);
        else
            for ddd1=1:kk
                log_like_ii_2(ddd1)=log_likeli_k(ddd1,n,np,u1h,u2h,y1{kk1},y2{kk1},gamma,observation_type);
            end
        end
    end
    
    % tempering last point only
    log_like_ii_2(end)=temperature*log_like_ii_2(end);
    
    if j1>1
        log_accept_ratio=sum(log_like_ii)+sum(log_like_ii_2)-Sample_log_dens+Sample_log_prior-likeli(m);
    else
        log_accept_ratio=sum(log_like_ii_2)-Sample_log_dens+Sample_log_prior-likeli(m);
    end
    
    
    %     disp([' ratio of likelihoods ' num2str(exp(log_accept_ratio)) ' or in log ' num2str(log_accept_ratio)])
    u=rand;

        
    ACCEPT_RATIO{1,ii}=[ACCEPT_RATIO{1,ii}; min(exp(log_accept_ratio),1)];
     
    if log(u)<=log_accept_ratio
        Sample{m+1,1}=proposal1;
        Sample{m+1,2}=proposal2;
        
        Sample_t{m+1,1}=u1h;
        Sample_t{m+1,2}=u2h;
        
        
        if j1>1
            log_likeli_store{m+1,1}=[log_like_ii(1,1:j1-1), log_like_ii_2];
        else
            log_likeli_store{m+1,1}=log_like_ii_2;
        end
        
        if j1>1
            likeli(m+1)=sum(log_like_ii)+sum(log_like_ii_2)-Sample_log_dens+Sample_log_prior;
        else
            likeli(m+1)=sum(log_like_ii_2)-Sample_log_dens+Sample_log_prior;
        end                       
        
    %         disp('........... proposal accepted .....................')
    else
        Sample{m+1,1}=Sample{m,1};
        Sample{m+1,2}=Sample{m,2};
        
        Sample_t{m+1,1}=Sample_t{m,1};
        Sample_t{m+1,2}=Sample_t{m,2};
        
        likeli(m+1)=likeli(m);
        
        log_likeli_store{m+1,1}=log_likeli_store{m,1};
    end
    
        
    
end