np=16; %%%%%%%%%%%%%%%%%%%%%

% time domain ifft
u1=ifft2(u1h)*n*n;
u2=ifft2(u2h)*n*n;
    xr=red2d(X,n,2);
    yr=red2d(Y,n,2);
          
% % ---- quiver reduced flow field
% x1r x2r precomputed
u1r=red2d(u1,n,2); 
u2r=red2d(u2,n,2);

figure(13)
subplot(131)
quiver(xr,yr,real(u1r),real(u2r),0.8); % scale=0 to see evolution!
hold on

[x1r,y2r]=meshgrid(x(1:np:n),y(1:np:n));
            
plot(x1r,y2r,'xk','LineWidth',3, 'MarkerSize',8)            
hold off

axis([0 L 0 L]);
ua=u1.*u1+u2.*u2;
umax=max(max(ua));
umax=sqrt(umax);
title(['t= ',num2str(t),',   Rey=',num2str(rey),', n=',num2str(n),', h=',...
    num2str(h),', max|u|=', num2str(real(umax))]);

subplot(132)
% [g1,g2]=g(X,Y,t); 
% g1r=red2d(g1,n,2);  % quiver current forcing
% g2r=red2d(g2,n,2);
% quiver(xr,yr,g1r,g2r, 0, 'r');

% set(gca,'FontSize',16);axis([0 2*pi 0 2*pi]);
voh=vof(u1h,u2h); 
vo=n*n*real(ifft2(voh)); % diff in Fourier
% vo=curl(real(u1),real(u2));
pcolor(x,y,vo);colormap ; shading interp; 
% pcolor(kv,kv,abs(voh).^.5); colormap Winter; %shading interp; 
% colorbar;
hold on
plot(x1r,y2r,'xk','LineWidth',3, 'MarkerSize',8)            
hold off
subplot(133)
pcolor(-n/2:(n/2-1),-n/2:(n/2-1),ifftshift(abs(voh))); colormap ;
% colorbar;
if want_video==1
    frame = getframe(gcf);
    writeVideo(writerObj,frame);
%     pause(.3)
end
pause(.01)
