
% load y_Temp_mcmc_test u1h u2h
save_plot=0;
file_output='smc_Gdiag_';
% load test2_N500M5_smc_adap


% load rholowp95highp95/test2_rp95_smc_adap_3.mat
%load test_G_991_95

% % % % % check if particles as resampled
if ess>N/3
    Resampling_temper
end


INIT1=0;
for i=1:N, INIT1=INIT1+U1{i,1};, end
INIT2=0;
for i=1:N, INIT2=INIT2+U2{i,1};, end
State2=INIT2/N;
State1=INIT1/N;
vorticity=vof(State1,State2);
vo=n*n*real(ifft2(vorticity));


[x1r,y2r]=meshgrid(x(1:np:n),y(1:np:n));

figure
subplot(2,2,1)
pcolor(x,y,vo);colormap ; shading interp;
title('SMC estimated initial vorticity')
hold on
plot(x1r,y2r,'xk','LineWidth',3, 'MarkerSize',8)



load y_Temp_mcmc_test u1h u2h

subplot(2,2,2)
voh=vof(u1h,u2h);
vo=n*n*real(ifft2(voh)); % diff in Fourier
pcolor(x,y,vo);colormap ; shading interp;
hold on
plot(x1r,y2r,'xk','LineWidth',3, 'MarkerSize',8)


title('true initial vorticity')


subplot(2,2,3)
u1_smc=ifft2(State1)*n*n;
u2_smc=ifft2(State2)*n*n;
u1r=red2d(u1_smc,n,2);
u2r=red2d(u2_smc,n,2);
xr=red2d(X,n,2);
yr=red2d(Y,n,2);
quiver(xr,yr,real(u1r),real(u2r),0.8); % scale=0 to see evolution!

hold on
plot(x1r,y2r,'xk','LineWidth',3, 'MarkerSize',6)

axis([0 L 0 L]);
% title('smc estimated initial condition')

subplot(2,2,4)
% time domain ifft
u1=ifft2(u1h)*n*n;
u2=ifft2(u2h)*n*n;
xr=red2d(X,n,2);
yr=red2d(Y,n,2);
% % ---- quiver reduced flow field
% x1r x2r precomputed
u1r=red2d(u1,n,2);
u2r=red2d(u2,n,2);
quiver(xr,yr,real(u1r),real(u2r),0.8); % scale=0 to see evolution!
hold on
plot(x1r,y2r,'xk','LineWidth',3, 'MarkerSize',6)


axis([0 L 0 L]);
% title('true initial condition')


% AA=n*n*real(ifft2(voh))-n*n*real(ifft2(vorticity));
% subplot(3,2,5)
% contour(x,y,AA)
% title('vorticity mcmc abs error')
% colorbar
% subplot(3,2,6)
% contour(x,y,AA./n*n*real(ifft2(voh)))
% title('vorticity mcmc rel error')
% colorbar


if save_plot==1
%    saveas(gcf,[file_output,'_post_mean'],'eps')
    saveas(gcf,[file_output,'_post_mean'],'fig')
end



figure

% subplot(1,2,1)
acc=[];
for ii=1:N, acc=[acc,(ACCEPT_RATIO{1,ii})];, end
plot(mean(acc,2))

hold on 
plot_jitter_monitor;
plot(Monitor_jitter,'m-')


% title('mean acceptance ratio vs n')
xlabel('k')
ylabel('Mean acceptance ratio')
if save_plot==1
%    saveas(gcf,[file_output,'_acc'],'eps')
    saveas(gcf,[file_output,'_acc'],'fig')
end


figure
plot(ESS)
hold on
plot(ones(size(ESS,1),1)*Nthresh,'--')
xlabel('k')
ylabel('ESS')


if save_plot==1
%    saveas(gcf,[file_output,'_ess'],'eps')
    saveas(gcf,[file_output,'_ess'],'fig')
end




coef1=[];
ind1_1=1;
ind1_2=2;

coef2=[];
ind2_1=2;
ind2_2=2;


coef3=[];
ind3_1=3;
ind3_2=2;


for ii=1:N
    coef1=[coef1,U2{ii,1}(ind1_1,ind1_2)];
    coef2=[coef2,U2{ii,1}(ind2_1,ind2_2)];
    coef3=[coef3,U2{ii,1}(ind3_1,ind3_2)];
end

grd=-2:.1:2;

hor_bar_length=.45;
dist=.05;
KKk=size(0:dist:hor_bar_length,2);

bins_ks=50;
divisor_prior=10;
divisor_true_obs=10;

figure
ssigma=sqrt(.5*delta*kmod(ind1_1,ind1_2).^(-2*alph));
subplot(231)
[F,XI]=ksdensity(real(coef1)/ssigma,'npoints',bins_ks);
plot(XI,F/sum(F))
hold on
plot(real( u2h(ind1_1,ind1_2))*ones(KKk,1)/ssigma,(0:dist:hor_bar_length)/divisor_true_obs,'r')
plot(grd,normpdf(grd,0,1)/divisor_prior,'k-')
title(['REAL coef',num2str(ind1_1-1),num2str(ind1_2-1)])
grid

subplot(234)
[F,XI]=ksdensity(imag(coef1)/ssigma,'npoints',bins_ks);
plot(XI,F/sum(F))
hold on 
plot(imag( u2h(ind1_1,ind1_2))*ones(KKk,1)/ssigma,(0:dist:hor_bar_length)/divisor_true_obs,'r')
plot(grd,normpdf(grd,0,1)/divisor_prior,'k-')
title(['IMAG coef',num2str(ind1_1-1),num2str(ind1_2-1)])
grid

ssigma=sqrt(.5*delta*kmod(ind2_1,ind2_2).^(-2*alph));
subplot(232)
[F,XI]=ksdensity(real(coef2)/ssigma,'npoints',bins_ks);
plot(XI,F/sum(F))
hold on
plot(real( u2h(ind2_1,ind2_2))*ones(KKk,1)/ssigma,(0:dist:hor_bar_length)/divisor_true_obs,'r')
plot(grd,normpdf(grd,0,1)/divisor_prior,'k-')
title(['REAL coef',num2str(ind2_1-1),num2str(ind2_2-1)])
grid

subplot(235)
[F,XI]=ksdensity(imag(coef2)/ssigma,'npoints',bins_ks);
plot(XI,F/sum(F))
hold on 
plot(imag( u2h(ind2_1,ind2_2))*ones(KKk,1)/ssigma,(0:dist:hor_bar_length)/divisor_true_obs,'r')
plot(grd,normpdf(grd,0,1)/divisor_prior,'k-')
title(['IMAG coef',num2str(ind2_1-1),num2str(ind2_2-1)])
grid

ssigma=sqrt(.5*delta*kmod(ind3_1,ind3_2).^(-2*alph));
subplot(233)
[F,XI]=ksdensity(real(coef3)/ssigma,'npoints',bins_ks);
plot(XI,F/sum(F))
hold on
plot(real( u2h(ind3_1,ind3_2))*ones(KKk,1)/ssigma,(0:dist:hor_bar_length)/divisor_true_obs,'r')
plot(grd,normpdf(grd,0,1)/divisor_prior,'k-')
title(['REAL coef',num2str(ind3_1-1),num2str(ind3_2-1)])
grid

subplot(236)
[F,XI]=ksdensity(imag(coef3)/ssigma,'npoints',bins_ks);
plot(XI,F/sum(F))
hold on 
plot(imag( u2h(ind3_1,ind3_2))*ones(KKk,1)/ssigma,(0:dist:hor_bar_length)/divisor_true_obs,'r')
plot(grd,normpdf(grd,0,1)/divisor_prior,'k-')
title(['IMAG coef',num2str(ind3_1-1),num2str(ind3_2-1)])
grid

if save_plot==1
%    saveas(gcf,[file_output,'_pdfs'],'eps')
    saveas(gcf,[file_output,'_pdfs'],'fig')
end