clear
% rng('shuffle')

 SEED=str2num('100');
 rand('twister',SEED)
 randn('state',2^32*rand)
% randn('state',SEED)

global X Y av bv mm w1 w2 w3 w4 c g1h g2h p1 p2 p3 regime KX KY L integration_method;

load y_Temp_mcmc_test


N=200; % number of particles
particles=cell(N,1);

% particle cells
% x-direction and weights
U1=cell(N,2);
% y-direction
U2=cell(N,2);

% just for tempered weights
U3=cell(N,1);

% sampling from the prior
for ii=1:N
    SampleFromPrior
    % stores intial condition always in 1- and 2- direction
    U1{ii,1}=u1h;
    U2{ii,1}=u2h;
    
    %  stores last state in trajectory (here initialisation)
    U1{ii,2}=u1h;
    U2{ii,2}=u2h;
    
    %  weights
%     %  at temperature=1
%     U1{ii,3}=[];
    %  at temperature    
    U3{ii,1}=[];
end
% temp storage for resampling
Utemp1=cell(N,2);
Utemp2=cell(N,2);

ACCEPT_RATIO=cell(1,N);
for l1=1:N
    ACCEPT_RATIO{1,l1}=[];
end
size_grid=length(y1{1})^2;

% mcmc stuff
num_mcmc_moves=10;

rho=.95;

rho1=.95;

Nthresh=N/3;
tolerance=1;
% determine low frequency components of population
k_thresh=5;
blk_ind=(n/2+1-k_thresh):(n/2+1+k_thresh);

ESS=[];
for j1=1:exsteps
    for kk=1:size_grid
        temperatures{j1,kk}=[];
    end
end

logWprev=zeros(N,1);
tic
for j1=1:exsteps % steps till next datapoint
    disp(['SMC iteration n=: ' num2str(j1) ' ............................................'])
    % unormalised weight matrix for each smc iteration use just last column
    % for resampling, the rest is needed for path mcmc
    logW=zeros(N,1);
    
    
    for ii=1:N
        
        % recall stored last velocity field
        u1h=U1{ii,2};
        u2h=U2{ii,2};
        % run solver forward
        for j2=1:intsteps % intermediate integration steps
            [u1h,u2h]=ns2dstepaa(u1h,u2h,n,h);
        end
        % record last velocity field
        U1{ii,2}=u1h;
        U2{ii,2}=u2h;
    end
    
    %target one measurement at a time
    for kk=1:size_grid
        for ii=1:N
            u1h=U1{ii,2};
            u2h=U2{ii,2};
            logW(ii,1)=log_likeli_k(kk,n,np,u1h,u2h,y1{j1},y2{j1},gamma,observation_type);
            
            %   unormalised log  weights (likelihood)
            U3{ii,1}=[U3{ii,1},logW(ii,1)];
            
            logW(ii,1)=logW(ii,1)+logWprev(ii,1); %%%% check
        end
        
        %         % copy untemperred weights for tempering
        %         for ii=1:N
        %              U3{ii,1}=U1{ii,3};
        %         end
        
        temperature=0;
        
        while temperature<1
            
            temperature_prev=temperature;
            
            if temperature>0
                
                for ii=1:N
                    u1h=U1{ii,2};
                    u2h=U2{ii,2};
                    logW(ii,1)=log_likeli_k(kk,n,np,u1h,u2h,y1{j1},y2{j1},gamma,observation_type);
                end
                
                [temperature,ess,logWeight]=find_temperature(logW,tolerance,Nthresh,N,temperature);
                
                for ii=1:N
                    U3{ii,1}(end)=temperature*U3{ii,1}(end)/temperature_prev;
                end
                
            else
                
                [temperature,ess,logWeight]=find_temperature(logW,tolerance,Nthresh,N,temperature);
                for ii=1:N
                    U3{ii,1}(end)=temperature*U3{ii,1}(end);
                end
            end
            
            
            
            
            temperatures{j1,kk}=[temperatures{j1,kk},temperature];
            
            
            % % %             temperature=.05;
            % % %             logW_temper=logW*temperature;
            % % %             logZ = log(sum(exp(logW_temper-max(max(logW_temper)))))+max(max(logW_temper));
            % % %             logWeight=logW_temper-ones(N,1)*logZ;
            
            disp(['k = ',num2str(kk),'...temperature= ',num2str(temperature),'....ESS: ',num2str(ess),' ..........'])
            ESS=[ESS; ess];
            [ mu,Sigma ] = get_mu_sigma(U1,U2,k_thresh,n,N,logWeight);
            
            
            
            
            % save besk1
            
            
            
            if temperature==1
                
                logWprev=logWeight;
                
                if ess<=(Nthresh+tolerance)
                    Resampling_temper
                end
            else
                % resample at temperatures<1
                Resampling_temper
            end
            
            % compute mean variance of low frequency components of population
% % %             U2temp2=U2;
            plot_pdfs_in_loop(U2,logWeight,logWprev,N,ACCEPT_RATIO,mu ,Sigma,k_thresh,n,1)
%             saveas(gcf,'figure_freezerho_1.fig')
            
            
            % mcmc move on the path
            for ii=1:N
                % disp(['XXX.......MCMC for particle: ' num2str(ii) ' ...........XXX'])
                
                mcmc_moves_for_smc_k_temper;
                
                U1{ii,1}=Sample{m+1,1};
                U2{ii,1}=Sample{m+1,2};
                U1{ii,2}=Sample_t{m+1,1};
                U2{ii,2}=Sample_t{m+1,2};
                U3{ii,1}=log_likeli_store{m+1,1};
                %                 if j1>1
                %                     U3{ii,1}=[log_like_ii(1,1:j1-1), log_like_ii_2];
                %                 else
                %                     U3{ii,1}=log_like_ii_2;
                %                 end
                
            end
            
            plot_pdfs_in_loop(U2,logWeight,logWprev,N,ACCEPT_RATIO,mu ,Sigma,k_thresh,n,2)
            %             saveas(gcf,'figure_freezerho_2.fig')
            %             simtime=toc;
            %             save besk2
            %             exit
            %             pause
        end
        
        
        %         % copy back tempered weights to untempered
        %         for ii=1:N
        %              U1{ii,3}=U3{ii,1};
        %         end
        
        
    end
    
    
    if j1<exsteps
        %         save(['test4_smc_adap_',num2str(j1),'.mat'],'-v7.3')
    end
    
end

simtime=toc;

% save -v7.3 test4_smc_adap